## cantata 2.4.1.ds1

=== CMakeLists.txt ===
PROJECT(cantata)

#  NOTE: If PROJECT_URL, or PROJECT_REV_URL, are changed, then cantata-dynamic, README, and
#        dbus/mpd.cantata.xml will need renaming/updating.
set(PROJECT_URL "cantata.mpd")
set(PROJECT_REV_URL "mpd.cantata")

if (CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
    set(OPENBSD TRUE)
endif ()

if (WIN32)
    # For some reason I chose mpd as the organization name for Windows builds. So, for config compatability, this is
    # left as mpd for now...
    set(ORGANIZATION_NAME "mpd")
else ()
    # Otherwise its set to the same as the project name. Not sure what else to set it to!!!
    set(ORGANIZATION_NAME ${CMAKE_PROJECT_NAME})
endif ()

cmake_minimum_required(VERSION 2.6)
cmake_policy(SET CMP0020 OLD)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_GENERATOR "DEB;RPM;TBZ2")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Qt Client for MPD")
set(CPACK_SOURCE_GENERATOR "TBZ2")
set(CPACK_PACKAGE_VERSION_MAJOR "2")
set(CPACK_PACKAGE_VERSION_MINOR "4")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_PACKAGE_VERSION_SPIN "")  # Use ".$number" - e.g. ".1"
set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
set(CANTATA_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
set(CANTATA_VERSION_FULL "${CANTATA_VERSION}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CANTATA_VERSION_WITH_SPIN "${CANTATA_VERSION_FULL}${CPACK_PACKAGE_VERSION_SPIN}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_WITH_SPIN}")
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CANTATA_VERSION_WITH_SPIN}")
set(CPACK_SOURCE_IGNORE_FILES  "/.svn/;/.git/;.gitignore;.github/;.project;CMakeLists.txt.user;README.md;/screenshots/")
include(CPack)
include(MacroLogFeature)

option(ENABLE_TAGLIB "Enable TagLib library (required for tag editing, replaygain calculation, device support, etc)" ON)
option(ENABLE_HTTP_STREAM_PLAYBACK "Enable playback of MPD HTTP streams (LibVLC or QtMultimedia)" ON)
option(ENABLE_FFMPEG "Enable ffmpeg/libav libraries (required for replaygain calculation)" ON)
option(ENABLE_MPG123 "Enable mpg123 libraries (required for replaygain calculation)" ON)
option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" ON)
option(ENABLE_HTTP_SERVER "Enable internal HTTP server to play non-MPD files" ON)
option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" OFF)
option(ENABLE_CATEGORIZED_VIEW "Enable support for categorised view" ON)

if (WIN32 OR APPLE OR HAIKU)
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
else ()
    option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" ON)
    option(ENABLE_REMOTE_DEVICES "Enable support for remote (sshfs, samba) devices" ON)
    option(ENABLE_SIMPLE_MPD_SUPPORT "Enable support for simple (Cantata controlled) MPD" ON)
    if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
        option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks" ON)
    else()
        option(ENABLE_UDISKS2 "Build UDisks2 backend, and NOT UDisks" OFF)
    endif()
endif ()
option(ENABLE_CDPARANOIA "Enable CDParanoia libraries (this or libCDIO_paranoia required for AudioCD support)" ON)
option(ENABLE_CDIOPARANOIA "Enable libCDIO_paranoia libraries (this or CDParanoia required for AudioCD support)" ON)
option(ENABLE_CDDB "Enable CDDB libraries (either this or MusicBrianz required for AudioCD support)" ON)
option(ENABLE_MUSICBRAINZ "Enable MusicBrianz libraries (either this or CDDB required for AudioCD support)" ON)
option(ENABLE_MTP "Enable MTP library (required to support MTP devices)" ON)
option(ENABLE_AVAHI "Enable automatic mpd server discovery" ${UNIX})

# Build all apps into top-level folder, so that can run dev versions without install
if (NOT WIN32 AND NOT APPLE)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
endif()

if(ENABLE_AVAHI)
    find_package(Avahi)
    macro_log_feature(AVAHI_FOUND "Avahi Support" "Automatic MPD-Server Detection" "https://www.avahi.org/" FALSE "" "")
endif()

if (AVAHI_FOUND)
    set(CANTATA_SRCS ${CANTATA_SRCS} gui/findmpddialog.cpp gui/avahidiscovery.cpp gui/avahipoll.cpp)
    set(CANTATA_UIS ${CANTATA_UIS} gui/findmpddialog.ui)

    set(CANTATA_LIBS ${CANTATA_LIBS} ${AVAHI_LIBRARIES})
endif()

if (NOT APPLE AND NOT WIN32 AND NOT HAIKU)
    set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share"
        CACHE PATH "Define install directory for read-only architecture-independent data")
else ()
    set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}"
        CACHE PATH "Define install directory for read-only architecture-independent data")
endif ()

if (WIN32)
    set(CANTATA_ICON_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/icons/cantata)
elseif (APPLE)
    set(MACOSX_BUNDLE_BUNDLE_NAME Cantata)
    set(MACOSX_BUNDLE_EXECUTABLE cantata)
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CANTATA_VERSION})
    set(MACOSX_BUNDLE_VERSION ${CANTATA_VERSION})
    set(MACOSX_BUNDLE_LONG_VERSION_STRING ${CANTATA_VERSION_WITH_SPIN})
    set(MACOSX_BUNDLE_ICON_FILE cantata.icns)
    set(CANTATA_APP_CONTENTS_DIR ${CMAKE_INSTALL_PREFIX}/Cantata.app/Contents)
    set(MACOSX_BUNDLE_RESOURCES ${CANTATA_APP_CONTENTS_DIR}/Resources)
    set(MACOSX_BUNDLE_APP_DIR ${CANTATA_APP_CONTENTS_DIR}/MacOS)
    set(CANTATA_ICON_INSTALL_PREFIX ${MACOSX_BUNDLE_RESOURCES}/icons/cantata)
elseif (NOT HAIKU)
    set(CANTATA_ICON_INSTALL_PREFIX ${SHARE_INSTALL_PREFIX}/icons/hicolor)
endif ()

if (NOT WIN32 AND NOT APPLE AND ENABLE_DEVICES_SUPPORT AND ENABLE_UDISKS2)
    set(WITH_SOLID_UDISKS2 ON)
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message("-- Set build type to ${CMAKE_BUILD_TYPE}")
endif ()

if (NOT APPLE AND NOT WIN32)
    if (CANTATA_HELPERS_LIB_DIR AND CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(LINUX_LIB_DIR ${CANTATA_HELPERS_LIB_DIR})
    else ()
        set(LINUX_LIB_DIR lib)
    endif ()
endif ()


if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND NOT APPLE AND NOT WIN32 AND NOT HAIKU)
    set(CMAKE_INSTALL_PREFIX "/usr")
    message("-- Set install prefix to ${CMAKE_INSTALL_PREFIX}")
endif ()

if (ENABLE_TAGLIB)
    if (NOT TAGLIB_FOUND)
        set(TAGLIB_MIN_VERSION "1.6")
        find_package(Taglib)
    endif()
    macro_log_feature(TAGLIB_FOUND "TagLib" "Tag editor, file organiser, etc." "http://taglib.github.io/")
endif ()

if (TAGLIB_FOUND)
    if (ENABLE_DEVICES_SUPPORT AND (ENABLE_CDIOPARANOIA OR ENABLE_CDPARANOIA))
        # Issue 1021 - prefer libcdio_paranoia over plain cdparanoia
        if (ENABLE_CDIOPARANOIA)
            find_package(Cdioparanoia)
            macro_log_feature(CDIOPARANOIA_FOUND "libcdio_paranoia" "CD ripping." "https://www.gnu.org/software/libcdio/")
        endif()
        if (NOT CDIOPARANOIA_FOUND)
            find_package(Cdparanoia)
            macro_log_feature(CDPARANOIA_FOUND "libcdda_paranoia" "CD ripping." "http://www.xiph.org/paranoia")
        endif()
        if (CDIOPARANOIA_FOUND OR CDPARANOIA_FOUND)
            if (ENABLE_CDDB)
                find_package(CDDB)
                macro_log_feature(CDDB_FOUND "libcddb" "CD info retrieval via CDDB." "http://libcddb.sourceforge.net")
            endif ()
            if (ENABLE_MUSICBRAINZ)
                find_package(MusicBrainz5)
                macro_log_feature(MUSICBRAINZ5_FOUND "libmusicbrainz5" "CD info retrieval via MusicBrainz." "http://musicbrainz.org/doc/libmusicbrainz")
            endif ()
        endif ()
    endif ()

    set(ENABLE_TAGEDITOR_SUPPORT 1)
    set(ENABLE_TRACKORGANIZER_SUPPORT 1)
    include(CheckCXXSourceCompiles)
    set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
    set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")

    check_cxx_source_compiles("#include <asftag.h>
                            int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
    if (NOT TAGLIB_ASF_FOUND)
        message("TagLib does not have ASF support compiled in.")
    endif ()

    check_cxx_source_compiles("#include <mp4tag.h>
                            int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
    if (NOT TAGLIB_MP4_FOUND)
        message("TagLib does not have MP4 support compiled in.")
    endif ()

    check_cxx_source_compiles("#include <opusfile.h>
                            int main() { TagLib::Ogg::Opus::File *f=0; return 0;}" TAGLIB_OPUS_FOUND)
    if (NOT TAGLIB_OPUS_FOUND)
        message("TagLib does not have OPUS support compiled in.")
    endif ()

    set(CMAKE_REQUIRED_INCLUDES)
    set(CMAKE_REQUIRED_LIBRARIES)

    #include(CheckTagLibFileName)
    #check_taglib_filename(COMPLEX_TAGLIB_FILENAME)

    add_definitions(${TAGLIB_CFLAGS})

    if (ENABLE_FFMPEG)
        find_package(FFMPEG)
        macro_log_feature(FFMPEG_FOUND "libavcodec/libavutil/libavformat" "ReplayGain calculation." "http://ffmpeg.org")
    endif ()
    if (ENABLE_MPG123)
        find_package(MPG123)
        macro_log_feature(MPG123_FOUND "libmpg123" "ReplayGain calculation." "http://www.mpg123.de")
    endif ()
    if (ENABLE_MTP AND ENABLE_DEVICES_SUPPORT AND NOT WIN32 AND NOT APPLE)
        find_package(Mtp)
        macro_log_feature(MTP_FOUND "libmtp" "MTP Device Support." "http://libmtp.sourceforge.net")
    endif ()
else (TAGLIB_FOUND)
   set(ENABLE_DEVICES_SUPPORT OFF)
endif ()

if (NOT MTP_FOUND)
   set(ENABLE_UNCACHED_MTP OFF)
endif ()

find_package(Qt5Widgets REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Sql REQUIRED)

set(CMAKE_AUTOMOC TRUE)
set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
set(CMAKE_CXX_STANDARD 11)

set(QTCORELIBS ${Qt5Core_LIBRARIES})
set(QTNETWORKLIBS ${Qt5Network_LIBRARIES})
set(QTGUILIBS ${Qt5Gui_LIBRARIES})
set(QTLIBS ${QTCORELIBS} ${Qt5Widgets_LIBRARIES} ${QTNETWORKLIBS} ${QTGUILIBS} ${Qt5Xml_LIBRARIES} ${Qt5Concurrent_LIBRARIES} ${Qt5Svg_LIBRARIES} ${Qt5Sql_LIBRARIES})
set(QTINCLUDES ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Concurrent_INCLUDE_DIRS}
    ${Qt5Svg_INCLUDE_DIRS} ${Qt5Sql_INCLUDE_DIRS})
add_definitions(${Qt5Widgets_DEFINITIONS} ${Qt5Network_DEFINITIONS} ${Qt5Xml_DEFINITIONS} ${Qt5Concurrent_DEFINITIONS} ${Qt5Svg_DEFINITIONS} ${Qt5Sql_DEFINITIONS})
if (Qt5_POSITION_INDEPENDENT_CODE)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")
endif ()

if (APPLE OR WIN32 OR HAIKU)
    get_target_property(QT_QMAKE_EXECUTABLE Qt5::qmake IMPORTED_LOCATION)
    exec_program(${QT_QMAKE_EXECUTABLE} ARGS -query QT_INSTALL_TRANSLATIONS OUTPUT_VARIABLE QT_TRANSLATIONS_DIR)
else ()
    find_package(Qt5DBus REQUIRED)
    set(QT_QTDBUS_FOUND 1) # required for config.h !!!
    set(QTLIBS ${QTLIBS} ${Qt5DBus_LIBRARIES})
    set(QTINCLUDES ${QTINCLUDES} ${Qt5DBus_INCLUDE_DIRS})
    add_definitions(${Qt5DBus_DEFINITIONS})
endif ()

if (ENABLE_HTTP_STREAM_PLAYBACK)
    if (ENABLE_LIBVLC)
        find_package(LIBVLC REQUIRED)
        macro_log_feature(LIBVLC_FOUND "libVLC" "MPD HTTP stream playback." "http://videolan.org")
        add_definitions(-DLIBVLC_FOUND)
        include_directories(${LIBVLC_INCLUDE_DIR})
        set(CANTATA_LIBS ${CANTATA_LIBS} ${LIBVLC_LIBRARY})
    else ()
        find_package(Qt5Multimedia REQUIRED)
        macro_log_feature(Qt5Multimedia_FOUND "Qt5Multimedia" "MPD HTTP stream playback." "http://qtproject.org")
        include_directories(${Qt5Multimedia_INCLUDE_DIRS})
        add_definitions(${Qt5Multimedia_DEFINITIONS})
        set(CANTATA_LIBS ${CANTATA_LIBS} ${Qt5Multimedia_LIBRARIES})
    endif ()
    set(CANTATA_SRCS ${CANTATA_SRCS} mpd-interface/httpstream.cpp)
endif ()

find_package(ZLIB REQUIRED)

if (APPLE)
    set(CANTATA_SRCS ${CANTATA_SRCS} mac/dockmenu.cpp mac/macnotify.mm)

=== tags/CMakeLists.txt ===
include_directories(${QTINCLUDES} ${TAGLIB_INCLUDES} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
set(CANTATA_TAGS_SRCS main.cpp taghelper.cpp tags.cpp filetyperesolver.cpp ../mpd-interface/song.cpp)

if (WIN32)
    set(CMAKE_BUILD_TYPE "Release")
    ADD_EXECUTABLE(cantata-tags WIN32 ${CANTATA_TAGS_SRCS})
    install(TARGETS cantata-tags DESTINATION ${CMAKE_INSTALL_PREFIX})
elseif (APPLE)
    set(CMAKE_BUILD_TYPE "Release")
    ADD_EXECUTABLE(cantata-tags ${CANTATA_TAGS_SRCS})
    #install(TARGETS cantata-tags DESTINATION ${MACOSX_BUNDLE_APP_DIR})
else ()
    ADD_EXECUTABLE(cantata-tags ${CANTATA_TAGS_SRCS})
    install(TARGETS cantata-tags RUNTIME DESTINATION ${LINUX_LIB_DIR}/cantata)
endif ()

add_definitions(-DCANTATA_TAG_SERVER -DCANTATA_NO_UI_FUNCTIONS)
target_link_libraries(cantata-tags ${TAGLIB_LIBRARIES} ${QTGUILIBS} ${QTCORELIBS} ${QTNETWORKLIBS})
if (TAGLIB-EXTRAS_FOUND)
    target_link_libraries(cantata-tags ${TAGLIB-EXTRAS_LIBRARIES})
    include_directories(${TAGLIB-EXTRAS_INCLUDES})
endif ()

=== translations/CMakeLists.txt ===
file(GLOB TS_FILES cantata_*.ts)
foreach (TS_FILE ${TS_FILES})
    get_filename_component(TRANS ${TS_FILE} NAME_WE)
    list(APPEND CANTATA_TRANS "${TRANS}")
endforeach ()

find_program(LRELEASE_EXECUTABLE lrelease PATHS /usr/lib64/qt5/bin/)

if (LRELEASE_EXECUTABLE)
    set(catalogname cantata)
    add_custom_target(translations ALL)
    foreach(TRANS ${CANTATA_TRANS})
        if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${TRANS}.ts)
            set(CUR_TS_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${TRANS}.ts)
            set(CUR_QM_FILE ${CMAKE_CURRENT_BINARY_DIR}/${TRANS}.qm)
            add_custom_command(TARGET translations
                COMMAND ${LRELEASE_EXECUTABLE} ARGS ${CUR_TS_FILE} -qm ${CUR_QM_FILE}
                DEPENDS ${CUR_TS_FILE})
            if (WIN32)
                install(FILES ${CUR_QM_FILE} DESTINATION ${CMAKE_INSTALL_PREFIX}/translations/)
            elseif (APPLE)
                install(FILES ${CUR_QM_FILE} DESTINATION ${MACOSX_BUNDLE_RESOURCES}/translations/)
            else ()
                install(FILES ${CUR_QM_FILE} DESTINATION ${SHARE_INSTALL_PREFIX}/cantata/translations/)
            endif ()
        endif ()
    endforeach()
else ()
    message("------\n"
            "NOTE: lrelease not found. Translations will *not* be installed\n"
            "------\n")
endif ()

=== 3rdparty/qtiocompressor/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories(${QTINCLUDES} ${ZLIB_INCLUDE_DIRS} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
ADD_LIBRARY(qtiocompressor STATIC qtiocompressor.cpp)

=== debian/changelog ===
cantata (2.4.1.ds1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 21 Mar 2020 07:31:37 -0700

cantata (2.4.1.ds1-1) unstable; urgency=medium

  [ Stuart Prescott ]
  * New upstream release.
  * Update Standards-Version to 4.5.0 (no changes required).

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set upstream metadata fields: Repository.
  * Switch to debhelper-compat (= 12).

 -- Stuart Prescott <stuart@debian.org>  Sun, 23 Feb 2020 17:36:49 +1100

=== debian/control ===
Source: cantata
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Stuart Prescott <stuart@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libcddb2-dev,
 libcdparanoia-dev,
 libebur128-dev,
 libmpg123-dev,
 libmtp-dev (>= 1.0.0),
 libmusicbrainz5-dev (>= 5.1.0+git20150707),
 libphonon4qt5-dev,
 libqt5svg5-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libtag-extras-dev,
 libtag1-dev,
 libudev-dev,
 libvlc-dev,
 libvlccore-dev,
 libx11-dev,
 pkg-config,
 pkg-kde-tools,
 qtbase5-dev,
 qtmultimedia5-dev,
 qttools5-dev-tools,
Standards-Version: 4.5.0
Homepage: https://github.com/CDrummond/cantata
Vcs-Browser: https://salsa.debian.org/multimedia-team/cantata
Vcs-Git: https://salsa.debian.org/multimedia-team/cantata.git

Package: cantata
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 fonts-font-awesome,
 libqt5sql5-sqlite,
Recommends:
 liburi-perl,
 libio-socket-ip-perl,
Provides:
 mpd-client,
Suggests:
 media-player-info,
 mpd,
Description: Qt client for the music player daemon (MPD)
 Cantata is a graphical front-end for the music player daemon, MPD. It provides
 many tools to view and manage the music collection including:
 .
   * library - sorted by album, artist, track, directory
   * albums with cover art
   * user defined playlists
   * dynamic playlists
   * streams, internet radio
   * lyrics
   * artist information from Wikipedia
   * device support for USB mass storage, MTP and CDs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT=5

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_REMOTE_DEVICES=OFF

override_dh_installexamples:
	dh_installexamples
	chmod -x $(CURDIR)/debian/cantata/usr/share/doc/cantata/examples/cantata-dynamic.service

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## cantata 2.4.2.ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
 cmake_minimum_required(VERSION 2.6)
 cmake_policy(SET CMP0020 OLD)
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+set (QT_MIN_VERSION 5.11)
 
 set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
 set(CPACK_GENERATOR "DEB;RPM;TBZ2")
@@ -28,7 +29,7 @@
 set(CPACK_SOURCE_GENERATOR "TBZ2")
 set(CPACK_PACKAGE_VERSION_MAJOR "2")
 set(CPACK_PACKAGE_VERSION_MINOR "4")
-set(CPACK_PACKAGE_VERSION_PATCH "1")
+set(CPACK_PACKAGE_VERSION_PATCH "2")
 set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
 set(CPACK_PACKAGE_VERSION_SPIN "")  # Use ".$number" - e.g. ".1"
 set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
@@ -217,12 +218,12 @@
    set(ENABLE_UNCACHED_MTP OFF)
 endif ()
 
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5Xml REQUIRED)
-find_package(Qt5Network REQUIRED)
-find_package(Qt5Concurrent REQUIRED)
-find_package(Qt5Svg REQUIRED)
-find_package(Qt5Sql REQUIRED)
+find_package(Qt5Widgets ${QT_MIN_VERSION} REQUIRED)
+find_package(Qt5Xml ${QT_MIN_VERSION} REQUIRED)
+find_package(Qt5Network ${QT_MIN_VERSION} REQUIRED)
+find_package(Qt5Concurrent ${QT_MIN_VERSION} REQUIRED)
+find_package(Qt5Svg ${QT_MIN_VERSION} REQUIRED)
+find_package(Qt5Sql ${QT_MIN_VERSION} REQUIRED)
 
 set(CMAKE_AUTOMOC TRUE)
 set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
@@ -266,10 +267,3 @@
         add_definitions(${Qt5Multimedia_DEFINITIONS})
         set(CANTATA_LIBS ${CANTATA_LIBS} ${Qt5Multimedia_LIBRARIES})
     endif ()
-    set(CANTATA_SRCS ${CANTATA_SRCS} mpd-interface/httpstream.cpp)
-endif ()
-
-find_package(ZLIB REQUIRED)
-
-if (APPLE)
-    set(CANTATA_SRCS ${CANTATA_SRCS} mac/dockmenu.cpp mac/macnotify.mm)

=== replaygain/CMakeLists.txt ===
if (FFMPEG_FOUND OR MPG123_FOUND)
    include_directories(${QTINCLUDES} ${ZLIB_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
    if (FFMPEG_FOUND)
        set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} ffmpeginput.cpp)
        include_directories(${FFMPEG_INCLUDE_DIRS})
    endif ()
    if (MPG123_FOUND)
        set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} mpg123input.cpp)
        include_directories(${MPG123_INCLUDE_DIRS})
    endif ()

    set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} main.cpp replaygain.cpp trackscanner.cpp jobcontroller.cpp ../support/thread.cpp)

    if (WIN32)
        set(CMAKE_BUILD_TYPE "Release")
        ADD_EXECUTABLE(cantata-replaygain WIN32 ${CANTATA_RG_SRCS} ${CANTATA_PO})
        install(TARGETS cantata-replaygain DESTINATION ${CMAKE_INSTALL_PREFIX})
    elseif (APPLE)
        set(CMAKE_BUILD_TYPE "Release")
        ADD_EXECUTABLE(cantata-replaygain ${CANTATA_RG_SRCS} ${CANTATA_PO})
#        install(TARGETS cantata-replaygain DESTINATION ${MACOSX_BUNDLE_APP_DIR})
    else ()
        ADD_EXECUTABLE(cantata-replaygain ${CANTATA_RG_SRCS})
        install(TARGETS cantata-replaygain RUNTIME DESTINATION ${LINUX_LIB_DIR}/cantata)
    endif ()

    find_package(Ebur128)

    if (EBUR128_FOUND)
        message("-- Using system libebur128")
        include_directories(${EBUR128_INCLUDE_DIR})
        target_link_libraries(cantata-replaygain ${EBUR128_LIBRARY})
    else ()
        message("-- Using supplied libebur128")
        include_directories(${CMAKE_SOURCE_DIR}/3rdparty)
        add_subdirectory(${CMAKE_SOURCE_DIR}/3rdparty/ebur128 ${CMAKE_BINARY_DIR}/3rdparty/ebur128)
        target_link_libraries(cantata-replaygain ebur128)
    endif ()

    if (FFMPEG_FOUND)
        target_link_libraries(cantata-replaygain ${FFMPEG_LIBRARIES})
    endif ()
    if (MPG123_FOUND)
        target_link_libraries(cantata-replaygain ${MPG123_LIBRARIES})
    endif ()
    target_link_libraries(cantata-replaygain ${QTCORELIBS})
    if (UNIX AND NOT APPLE)
        target_link_libraries(cantata-replaygain -lpthread)
    endif ()
endif ()

=== support/CMakeLists.txt ===
set(SUPPORT_CORE_SRCS utils.cpp thread.cpp)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${QTINCLUDES})

add_library(support-core STATIC ${SUPPORT_CORE_SRCS})
    
set (SUPPORT_SRCS icon.cpp fancytabwidget.cpp messagewidget.cpp buddylabel.cpp action.cpp actioncollection.cpp lineedit.cpp
     configuration.cpp gtkstyle.cpp spinner.cpp messagebox.cpp inputdialog.cpp thread.cpp squeezedtextlabel.cpp proxystyle.cpp
     pagewidget.cpp combobox.cpp configdialog.cpp monoicon.cpp)

if (APPLE)
    set(SUPPORT_SRCS ${SUPPORT_SRCS} osxstyle.cpp flattoolbutton.cpp windowmanager.cpp)
endif ()

set(SUPPORT_SRCS ${SUPPORT_SRCS} pathrequester.cpp kmessagewidget.cpp dialog.cpp shortcutsmodel.cpp
    shortcutssettingswidget.cpp keysequencewidget.cpp acceleratormanager.cpp urllabel.cpp)
set(SUPPORT_UIS shortcutssettingswidget.ui)

qt5_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
qt5_add_resources(SUPPORT_RC_SRCS support.qrc)

add_library(support STATIC ${SUPPORT_SRCS} ${SUPPORT_UI_HDRS} ${SUPPORT_RC_SRCS})

=== windows/CMakeLists.txt ===
set(WINDOWS_APP_NAME Cantata)
set(WINDOWS_COMPANY_NAME Cantata)
set(WINDOWS_URL "http://${PROJECT_URL}")

if (CANTATA_SSL_LIBS)
    set(EXTRA_WIN_LIBS ${EXTRA_WIN_LIBS} ${CANTATA_SSL_LIBS})
    set(CANTATA_SSL_WIN_NSIS_INSTALL "file \"libeay32.dll\"\n    file \"ssleay32.dll\"")
endif (CANTATA_SSL_LIBS)

FILE(TO_CMAKE_PATH $ENV{QTDIR} QT_DIR)
set(QT_BINARY_DIR ${QT_DIR}/bin)
set(QT_PLUGINS_DIR ${QT_DIR}/plugins)
set(QT_TRANSLATIONS_DIR ${QT_DIR}/translations)

configure_file(cantata.nsi.cmake ${CMAKE_CURRENT_BINARY_DIR}/cantata.nsi)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cantata.nsi cantata.ico LICENSE.txt "Cantata README.txt" DESTINATION ${CMAKE_INSTALL_PREFIX})

# Qt image formats...
install(FILES ${QT_PLUGINS_DIR}/imageformats/qjpeg.dll ${QT_PLUGINS_DIR}/imageformats/qsvg.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/imageformats/)

# Qt iconengines...
install(FILES ${QT_PLUGINS_DIR}/iconengines/qsvgicon.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/iconengines/)

# Qt windows platform plugin...
install(FILES ${QT_PLUGINS_DIR}/platforms/qwindows.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/platforms/)

# Qt SQL driver...
install(FILES ${QT_PLUGINS_DIR}/sqldrivers/qsqlite.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/sqldrivers/)

# Qt MultiMedia
install(FILES ${QT_PLUGINS_DIR}/mediaservice/dsengine.dll ${QT_PLUGINS_DIR}/mediaservice/qtmedia_audioengine.dll DESTINATION ${CMAKE_INSTALL_PREFIX}/mediaservice/)

# Qt, taglib, and zlib libraries...
set(EXTRA_WIN_LIBS ${EXTRA_WIN_LIBS}
    ${QT_BINARY_DIR}/Qt5Core.dll ${QT_BINARY_DIR}/Qt5Gui.dll ${QT_BINARY_DIR}/Qt5Network.dll ${QT_BINARY_DIR}/Qt5Svg.dll ${QT_BINARY_DIR}/Qt5Xml.dll
    ${QT_BINARY_DIR}/Qt5Widgets.dll ${QT_BINARY_DIR}/Qt5WinExtras.dll ${QT_BINARY_DIR}/Qt5Sql.dll
    ${QT_BINARY_DIR}/libgcc_s_dw2-1.dll ${QT_BINARY_DIR}/libstdc++-6.dll ${QT_BINARY_DIR}/libwinpthread-1.dll
    ${ZLIB_INCLUDE_DIR}/../bin/libz-1.dll ${TAGLIB_INCLUDES}/../bin/libtag.dll)

if (ENABLE_HTTP_STREAM_PLAYBACK)
    set(EXTRA_WIN_LIBS ${EXTRA_WIN_LIBS} ${QT_BINARY_DIR}/Qt5Multimedia.dll)
endif()

# Qt translation files...
file(GLOB qt_trans ${QT_TRANSLATIONS_DIR}/qt_*.qm)
foreach(qm ${qt_trans})
    if (NOT ${qm} MATCHES "(${QT_TRANSLATIONS_DIR}/qt_help*)")
        list(APPEND qt_translations "${qm}")
    endif ()
endforeach()
install(FILES ${qt_translations} DESTINATION ${CMAKE_INSTALL_PREFIX}/translations/)

install(FILES ${EXTRA_WIN_LIBS} DESTINATION ${CMAKE_INSTALL_PREFIX})
install(FILES LICENSE.txt DESTINATION ${CMAKE_INSTALL_PREFIX} RENAME "Cantata License (GPL V3).txt")
install(FILES ../icons/cantata32.png DESTINATION ${CMAKE_INSTALL_PREFIX}/icons/ RENAME cantata.png)

=== streams/icons/CMakeLists.txt ===
set(CANTATA_INSTALL_STREAM_ICONS stream.png)

if (WIN32)
    install(FILES ${CANTATA_INSTALL_STREAM_ICONS} DESTINATION ${CMAKE_INSTALL_PREFIX}/icons/)
elseif (APPLE)
    install(FILES ${CANTATA_INSTALL_STREAM_ICONS} DESTINATION ${MACOSX_BUNDLE_RESOURCES}/icons/)
else ()
    install(FILES ${CANTATA_INSTALL_STREAM_ICONS} DESTINATION ${SHARE_INSTALL_PREFIX}/${CMAKE_PROJECT_NAME}/icons/)
endif ()

=== debian/changelog ===
cantata (2.4.2.ds1-3) unstable; urgency=medium

  * Restrict B-D on libudev-dev to linux-any (Closes: #820011).
  * Add patch to fix FTBFS with ffmpeg 5.0 (Closes: #1004618).
  * Silence spurious lintian tags.

 -- Stuart Prescott <stuart@debian.org>  Tue, 01 Feb 2022 11:35:22 +1100

cantata (2.4.2.ds1-2) unstable; urgency=medium

  * Minor packaging updates from Janitor/lintian-brush
    - Update Standards-Version to 4.6.0 (no changes required).
    - Add debian/upstream/metadata.
  * Update build dependencies with thanks to Thomas Uhle for the suggestions
    (Closes: #985734).

 -- Stuart Prescott <stuart@debian.org>  Mon, 18 Oct 2021 18:29:37 +1100

cantata (2.4.2.ds1-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debehlper-compat (= 13).
  * Add Rules-Requires-Root: no.

 -- Stuart Prescott <stuart@debian.org>  Sun, 27 Sep 2020 18:05:52 +1000

=== debian/control ===
--- 
+++ 
@@ -1,41 +1,40 @@
 Source: cantata
 Section: sound
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Stuart Prescott <stuart@debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
+ libavahi-client-dev,
+ libavahi-common-dev,
  libavcodec-dev,
  libavformat-dev,
  libavutil-dev,
  libcddb2-dev,
- libcdparanoia-dev,
+ libcdio-paranoia-dev,
+ libdbus-1-dev,
  libebur128-dev,
  libmpg123-dev,
  libmtp-dev (>= 1.0.0),
  libmusicbrainz5-dev (>= 5.1.0+git20150707),
- libphonon4qt5-dev,
  libqt5svg5-dev,
  libspeex-dev,
  libspeexdsp-dev,
  libtag-extras-dev,
  libtag1-dev,
- libudev-dev,
- libvlc-dev,
- libvlccore-dev,
- libx11-dev,
+ libudev-dev [linux-any],
  pkg-config,
  pkg-kde-tools,
  qtbase5-dev,
  qtmultimedia5-dev,
  qttools5-dev-tools,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/CDrummond/cantata
 Vcs-Browser: https://salsa.debian.org/multimedia-team/cantata
 Vcs-Git: https://salsa.debian.org/multimedia-team/cantata.git
+Rules-Requires-Root: no
 
 Package: cantata
 Architecture: any

## cantata 2.5.0%2Bgit20250603.c4cc69c

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
-PROJECT(cantata)
+cmake_minimum_required(VERSION 3.0)
+project(cantata)
+cmake_policy(SET CMP0020 NEW)
 
 #  NOTE: If PROJECT_URL, or PROJECT_REV_URL, are changed, then cantata-dynamic, README, and
 #        dbus/mpd.cantata.xml will need renaming/updating.
@@ -18,18 +20,18 @@
     set(ORGANIZATION_NAME ${CMAKE_PROJECT_NAME})
 endif ()
 
-cmake_minimum_required(VERSION 2.6)
-cmake_policy(SET CMP0020 OLD)
+
+
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
-set (QT_MIN_VERSION 5.11)
+set (QT_MIN_VERSION 5.5)
 
 set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
 set(CPACK_GENERATOR "DEB;RPM;TBZ2")
 set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Qt Client for MPD")
 set(CPACK_SOURCE_GENERATOR "TBZ2")
 set(CPACK_PACKAGE_VERSION_MAJOR "2")
-set(CPACK_PACKAGE_VERSION_MINOR "4")
-set(CPACK_PACKAGE_VERSION_PATCH "2")
+set(CPACK_PACKAGE_VERSION_MINOR "5")
+set(CPACK_PACKAGE_VERSION_PATCH "0")
 set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
 set(CPACK_PACKAGE_VERSION_SPIN "")  # Use ".$number" - e.g. ".1"
 set(CPACK_PACKAGE_CONTACT "Craig Drummond <craig.p.drummond@gmail.com>")
@@ -49,7 +51,8 @@
 option(ENABLE_PROXY_CONFIG "Enable proxy config in settings dialog" ON)
 option(ENABLE_HTTP_SERVER "Enable internal HTTP server to play non-MPD files" ON)
 option(ENABLE_LIBVLC "Use libVLC for MPD HTTP stream playback (if ENABLE_HTTP_STREAM_PLAYBACK=ON)" OFF)
-option(ENABLE_CATEGORIZED_VIEW "Enable support for categorised view" ON)
+option(ENABLE_CATEGORIZED_VIEW "Enable support for categorised view" OFF)
+option(ENABLE_SCROBBLING "Enable scrobbling" ON)
 
 if (WIN32 OR APPLE OR HAIKU)
     option(ENABLE_DEVICES_SUPPORT "Enable suport for external devices" OFF)
@@ -82,7 +85,6 @@
 
 if (AVAHI_FOUND)
     set(CANTATA_SRCS ${CANTATA_SRCS} gui/findmpddialog.cpp gui/avahidiscovery.cpp gui/avahipoll.cpp)
-    set(CANTATA_UIS ${CANTATA_UIS} gui/findmpddialog.ui)
 
     set(CANTATA_LIBS ${CANTATA_LIBS} ${AVAHI_LIBRARIES})
 endif()
@@ -168,35 +170,6 @@
 
     set(ENABLE_TAGEDITOR_SUPPORT 1)
     set(ENABLE_TRACKORGANIZER_SUPPORT 1)
-    include(CheckCXXSourceCompiles)
-    set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
-    set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")
-
-    check_cxx_source_compiles("#include <asftag.h>
-                            int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
-    if (NOT TAGLIB_ASF_FOUND)
-        message("TagLib does not have ASF support compiled in.")
-    endif ()
-
-    check_cxx_source_compiles("#include <mp4tag.h>
-                            int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
-    if (NOT TAGLIB_MP4_FOUND)
-        message("TagLib does not have MP4 support compiled in.")
-    endif ()
-
-    check_cxx_source_compiles("#include <opusfile.h>
-                            int main() { TagLib::Ogg::Opus::File *f=0; return 0;}" TAGLIB_OPUS_FOUND)
-    if (NOT TAGLIB_OPUS_FOUND)
-        message("TagLib does not have OPUS support compiled in.")
-    endif ()
-
-    set(CMAKE_REQUIRED_INCLUDES)
-    set(CMAKE_REQUIRED_LIBRARIES)
-
-    #include(CheckTagLibFileName)
-    #check_taglib_filename(COMPLEX_TAGLIB_FILENAME)
-
-    add_definitions(${TAGLIB_CFLAGS})
 
     if (ENABLE_FFMPEG)
         find_package(FFMPEG)
@@ -218,24 +191,17 @@
    set(ENABLE_UNCACHED_MTP OFF)
 endif ()
 
-find_package(Qt5Widgets ${QT_MIN_VERSION} REQUIRED)
-find_package(Qt5Xml ${QT_MIN_VERSION} REQUIRED)
-find_package(Qt5Network ${QT_MIN_VERSION} REQUIRED)
-find_package(Qt5Concurrent ${QT_MIN_VERSION} REQUIRED)
-find_package(Qt5Svg ${QT_MIN_VERSION} REQUIRED)
-find_package(Qt5Sql ${QT_MIN_VERSION} REQUIRED)
+find_package(Qt5 ${QT_MIN_VERSION} COMPONENTS Widgets Xml Network Concurrent Svg Sql REQUIRED)
 
 set(CMAKE_AUTOMOC TRUE)
-set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
+set(CMAKE_AUTOUIC TRUE)
+set(CMAKE_AUTORCC TRUE)
 set(CMAKE_CXX_STANDARD 11)
 
 set(QTCORELIBS ${Qt5Core_LIBRARIES})
 set(QTNETWORKLIBS ${Qt5Network_LIBRARIES})
 set(QTGUILIBS ${Qt5Gui_LIBRARIES})
 set(QTLIBS ${QTCORELIBS} ${Qt5Widgets_LIBRARIES} ${QTNETWORKLIBS} ${QTGUILIBS} ${Qt5Xml_LIBRARIES} ${Qt5Concurrent_LIBRARIES} ${Qt5Svg_LIBRARIES} ${Qt5Sql_LIBRARIES})
-set(QTINCLUDES ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5Core_INCLUDE_DIRS} ${Qt5Concurrent_INCLUDE_DIRS}
-    ${Qt5Svg_INCLUDE_DIRS} ${Qt5Sql_INCLUDE_DIRS})
-add_definitions(${Qt5Widgets_DEFINITIONS} ${Qt5Network_DEFINITIONS} ${Qt5Xml_DEFINITIONS} ${Qt5Concurrent_DEFINITIONS} ${Qt5Svg_DEFINITIONS} ${Qt5Sql_DEFINITIONS})
 if (Qt5_POSITION_INDEPENDENT_CODE)
     set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 else ()
@@ -249,8 +215,6 @@
     find_package(Qt5DBus REQUIRED)
     set(QT_QTDBUS_FOUND 1) # required for config.h !!!
     set(QTLIBS ${QTLIBS} ${Qt5DBus_LIBRARIES})
-    set(QTINCLUDES ${QTINCLUDES} ${Qt5DBus_INCLUDE_DIRS})
-    add_definitions(${Qt5DBus_DEFINITIONS})
 endif ()
 
 if (ENABLE_HTTP_STREAM_PLAYBACK)
@@ -258,12 +222,56 @@
         find_package(LIBVLC REQUIRED)
         macro_log_feature(LIBVLC_FOUND "libVLC" "MPD HTTP stream playback." "http://videolan.org")
         add_definitions(-DLIBVLC_FOUND)
-        include_directories(${LIBVLC_INCLUDE_DIR})
         set(CANTATA_LIBS ${CANTATA_LIBS} ${LIBVLC_LIBRARY})
     else ()
-        find_package(Qt5Multimedia REQUIRED)
+        find_package(Qt5 ${QT_MIN_VERSION} COMPONENTS Multimedia REQUIRED)
         macro_log_feature(Qt5Multimedia_FOUND "Qt5Multimedia" "MPD HTTP stream playback." "http://qtproject.org")
-        include_directories(${Qt5Multimedia_INCLUDE_DIRS})
-        add_definitions(${Qt5Multimedia_DEFINITIONS})
         set(CANTATA_LIBS ${CANTATA_LIBS} ${Qt5Multimedia_LIBRARIES})
     endif ()
+    set(CANTATA_SRCS ${CANTATA_SRCS} mpd-interface/httpstream.cpp)
+endif ()
+
+find_package(ZLIB REQUIRED)
+
+if (APPLE)
+    set(CANTATA_SRCS ${CANTATA_SRCS} mac/dockmenu.cpp mac/macnotify.mm)
+    find_package(IOKit)
+    if (IOKIT_FOUND)
+        set(CANTATA_LIBS ${CANTATA_LIBS} ${IOKIT_LIBRARY})
+        set(CANTATA_SRCS ${CANTATA_SRCS} mac/powermanagement.cpp)
+    endif ()
+    find_package(Foundation REQUIRED)
+    find_library(MAC_APPKIT_LIBRARY AppKit REQUIRED)
+    set(CANTATA_LIBS ${CANTATA_LIBS} ${FOUNDATION_LIBRARY} ${MAC_APPKIT_LIBRARY})
+    find_library(MAC_MEDIAPLAYER_LIBRARY MediaPlayer)
+    if (MAC_MEDIAPLAYER_LIBRARY)
+        set(CANTATA_SRCS ${CANTATA_SRCS} mac/macnowplaying.mm)
+        set(CANTATA_LIBS ${CANTATA_LIBS} ${MAC_MEDIAPLAYER_LIBRARY})
+        add_definitions(-DMAC_MEDIAPLAYER_FOUND)
+    endif ()
+elseif (WIN32)
+    find_package(Qt5 COMPONENTS WinExtras REQUIRED)
+    set(QTLIBS ${QTLIBS} ${Qt5WinExtras_LIBRARIES})
+    set(CANTATA_SRCS ${CANTATA_SRCS} windows/thumbnailtoolbar.cpp)
+endif ()
+
+# MusicBrainz requires exceptions to be enabled!
+if (MUSICBRAINZ5_FOUND)
+    message("-- Enabling exceptions")
+    if (CMAKE_COMPILER_IS_GNUCXX)
+        add_definitions("-fexceptions -UQT_NO_EXCEPTIONS")
+    endif (CMAKE_COMPILER_IS_GNUCXX)
+    if (CMAKE_C_COMPILER MATCHES "icc")
+        add_definitions(-fexceptions)
+    endif ()
+    if (MSVC)
+        add_definitions(-EHsc)
+    endif ()
+endif ()
+
+include_directories(${CMAKE_SOURCE_DIR}/3rdparty ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
+
+set(CANTATA_SRCS ${CANTATA_SRCS}
+    gui/settings.cpp gui/application.cpp gui/initialsettingswizard.cpp gui/mainwindow.cpp gui/preferencesdialog.cpp gui/customactionssettings.cpp
+    gui/interfacesettings.cpp gui/playbacksettings.cpp gui/serversettings.cpp gui/librarypage.cpp gui/customactions.cpp
+    gui/folderpage.cpp gui/trayitem.cpp gui/cachesettings.cpp gui/coverdialog.cpp gui/searchpage.cpp gui/stdactions.cpp

=== replaygain/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 if (FFMPEG_FOUND OR MPG123_FOUND)
-    include_directories(${QTINCLUDES} ${ZLIB_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
+    include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
     if (FFMPEG_FOUND)
         set(CANTATA_RG_SRCS ${CANTATA_RG_SRCS} ffmpeginput.cpp)
         include_directories(${FFMPEG_INCLUDE_DIRS})
@@ -24,18 +24,12 @@
         install(TARGETS cantata-replaygain RUNTIME DESTINATION ${LINUX_LIB_DIR}/cantata)
     endif ()
 
-    find_package(Ebur128)
+    target_link_libraries(cantata-replaygain support-core)
 
-    if (EBUR128_FOUND)
-        message("-- Using system libebur128")
-        include_directories(${EBUR128_INCLUDE_DIR})
-        target_link_libraries(cantata-replaygain ${EBUR128_LIBRARY})
-    else ()
-        message("-- Using supplied libebur128")
-        include_directories(${CMAKE_SOURCE_DIR}/3rdparty)
-        add_subdirectory(${CMAKE_SOURCE_DIR}/3rdparty/ebur128 ${CMAKE_BINARY_DIR}/3rdparty/ebur128)
-        target_link_libraries(cantata-replaygain ebur128)
-    endif ()
+    find_package(Ebur128 REQUIRED)
+
+    target_link_libraries(cantata-replaygain ${Ebur128_LIBRARIES})
+    target_include_directories(cantata-replaygain PRIVATE ${Ebur128_INCLUDEDIR})
 
     if (FFMPEG_FOUND)
         target_link_libraries(cantata-replaygain ${FFMPEG_LIBRARIES})

=== support/CMakeLists.txt ===
set(SUPPORT_CORE_SRCS utils.cpp thread.cpp)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

add_library(support-core STATIC ${SUPPORT_CORE_SRCS})
target_link_libraries(support-core ${QTLIBS})
    
set (SUPPORT_SRCS icon.cpp fancytabwidget.cpp messagewidget.cpp buddylabel.cpp action.cpp actioncollection.cpp lineedit.cpp
     configuration.cpp gtkstyle.cpp spinner.cpp messagebox.cpp inputdialog.cpp thread.cpp squeezedtextlabel.cpp proxystyle.cpp
     pagewidget.cpp combobox.cpp configdialog.cpp monoicon.cpp)

if (APPLE)
    set(SUPPORT_SRCS ${SUPPORT_SRCS} osxstyle.cpp flattoolbutton.cpp windowmanager.cpp)
endif ()

set(SUPPORT_SRCS ${SUPPORT_SRCS} pathrequester.cpp kmessagewidget.cpp dialog.cpp shortcutsmodel.cpp
    shortcutssettingswidget.cpp keysequencewidget.cpp acceleratormanager.cpp urllabel.cpp
    compat/qfontmetricscompat.h compat/qrandomgeneratorcompat.h compat/qrandomgeneratorcompat.cpp compat/qimagecompat.h)
set(SUPPORT_UIS shortcutssettingswidget.ui)

qt5_wrap_ui(SUPPORT_UI_HDRS ${SUPPORT_UIS})
qt5_add_resources(SUPPORT_RC_SRCS support.qrc)

add_library(support STATIC ${SUPPORT_SRCS} ${SUPPORT_UI_HDRS} ${SUPPORT_RC_SRCS})
target_link_libraries(support ${QTLIBS})

=== tags/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-include_directories(${QTINCLUDES} ${TAGLIB_INCLUDES} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
+include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
 set(CANTATA_TAGS_SRCS main.cpp taghelper.cpp tags.cpp filetyperesolver.cpp ../mpd-interface/song.cpp)
 
 if (WIN32)
@@ -18,5 +18,4 @@
 target_link_libraries(cantata-tags ${TAGLIB_LIBRARIES} ${QTGUILIBS} ${QTCORELIBS} ${QTNETWORKLIBS})
 if (TAGLIB-EXTRAS_FOUND)
     target_link_libraries(cantata-tags ${TAGLIB-EXTRAS_LIBRARIES})
-    include_directories(${TAGLIB-EXTRAS_INCLUDES})
 endif ()

=== translations/CMakeLists.txt ===
--- 
+++ 
@@ -4,17 +4,17 @@
     list(APPEND CANTATA_TRANS "${TRANS}")
 endforeach ()
 
-find_program(LRELEASE_EXECUTABLE lrelease PATHS /usr/lib64/qt5/bin/)
+find_package(Qt5LinguistTools ${QT_MIN_VERSION} QUIET)
 
-if (LRELEASE_EXECUTABLE)
-    set(catalogname cantata)
-    add_custom_target(translations ALL)
+if (Qt5LinguistTools_FOUND)
     foreach(TRANS ${CANTATA_TRANS})
         if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${TRANS}.ts)
             set(CUR_TS_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${TRANS}.ts)
             set(CUR_QM_FILE ${CMAKE_CURRENT_BINARY_DIR}/${TRANS}.qm)
-            add_custom_command(TARGET translations
-                COMMAND ${LRELEASE_EXECUTABLE} ARGS ${CUR_TS_FILE} -qm ${CUR_QM_FILE}
+            list(APPEND CANTATA_QMS_FILES ${CUR_QM_FILE})
+
+            add_custom_command(OUTPUT ${CUR_QM_FILE}
+                COMMAND ${Qt5_LRELEASE_EXECUTABLE} ARGS ${CUR_TS_FILE} -qm ${CUR_QM_FILE}
                 DEPENDS ${CUR_TS_FILE})
             if (WIN32)
                 install(FILES ${CUR_QM_FILE} DESTINATION ${CMAKE_INSTALL_PREFIX}/translations/)
@@ -25,6 +25,7 @@
             endif ()
         endif ()
     endforeach()
+    add_custom_target(translations ALL DEPENDS ${CANTATA_QMS_FILES})
 else ()
     message("------\n"
             "NOTE: lrelease not found. Translations will *not* be installed\n"

=== 3rdparty/kcategorizedview/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(KCAT_SOURCES
  kcategorizedsortfilterproxymodel.cpp
  kcategorizedview.cpp 
  kcategorydrawer.cpp
)

include_directories( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

add_definitions(-DKITEMVIEWS_NO_DEPRECATED)

ADD_LIBRARY(kcategorizedview STATIC
  ${KCAT_SOURCES}
)

target_link_libraries(kcategorizedview ${QTLIBS})

=== 3rdparty/qtiocompressor/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories(${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
ADD_LIBRARY(qtiocompressor STATIC qtiocompressor.cpp)
target_link_libraries(qtiocompressor ${QTLIBS})

=== 3rdparty/qtsingleapplication/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(SINGLEAPP-SOURCES
    qtlocalpeer.cpp
    qtlockedfile.cpp
    qtsingleapplication.cpp
    qtsinglecoreapplication.cpp
)

include_directories( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

if(WIN32)
  set(SINGLEAPP-SOURCES ${SINGLEAPP-SOURCES} qtlockedfile_win.cpp)
else()
  set(SINGLEAPP-SOURCES ${SINGLEAPP-SOURCES} qtlockedfile_unix.cpp)
endif()

ADD_LIBRARY(qtsingleapplication STATIC
    ${SINGLEAPP-SOURCES}
)

target_link_libraries(qtsingleapplication ${QTLIBS})

=== 3rdparty/qxt/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(QXT-SOURCES
  qxtglobal.cpp
  qxtglobalshortcut.cpp
)

if (NOT WIN32 AND NOT APPLE)
  find_package(X11)
  include_directories(${X11_INCLUDE_DIR})
endif ()

include_directories( ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )

if(WIN32)
  set(QXT-SOURCES ${QXT-SOURCES} qxtglobalshortcut_win.cpp)
elseif(APPLE)
  set(QXT-SOURCES ${QXT-SOURCES} qxtglobalshortcut_mac.cpp)
else()
  set(QXT-SOURCES ${QXT-SOURCES} qxtglobalshortcut_x11.cpp)
endif()

ADD_LIBRARY(qxt STATIC
  ${QXT-SOURCES}
)

target_link_libraries(qxt ${QTLIBS})
